Revive lcov reporting
[build-farm.git] / build_test.fns
1 #!/bin/sh -*- mode: shell-script; -*-
2
3 # build_farm -- distributed build/test architecture for samba, rsync, etc
4
5 # Copyright (C) 2001 by Andrew Tridgell <tridge@samba.org>
6 # Copyright (C) 2001 by Andrew Bartlett <abartlet@samba.org>
7 # Copyright (C) 2001, 2003 by Martin Pool <mbp@samba.org>
8
9 # default maximum runtime for any command
10 MAXTIME=25200 # 7 hours
11 SMBD_MAXTIME=18000 # 5 hours for a samba process ..
12 # default maximum memory size (100M) for any command
13 MAXMEM=100000
14 RUN_FROM_BUILD_FARM=yes
15 export RUN_FROM_BUILD_FARM
16 export MAXTIME SMBD_MAXTIME
17
18 deptrees="";
19
20 build_test_fns_id='$Id$'
21
22 copy_dir() {
23         Tsrc=$1
24         Tdst=$2
25         pwd
26         echo rsync -a --delete $Tsrc/ $Tdst
27         rsync -a --delete $Tsrc/ $Tdst || return 1
28         return 0
29 }
30
31 #############################
32 # build a signature of a tree, used to see if we
33 # need to rebuild 
34 #############################
35
36 sum_tree() {
37         sum_tree_test_root=$1
38         sum_tree_tree=$2
39         sum_tree_sum=$3
40         sum_tree_scm=$4
41         find $sum_tree_test_root/$sum_tree_tree -type f -print | grep -v version.h | sort | xargs sum > $sum_tree_sum
42         sum build_test build_test.fns >> $sum_tree_sum
43
44         if [ -f "$host.fns" ]; then
45                 sum $host.fns >> $sum_tree_sum
46         else
47                 sum generic.fns >> $sum_tree_sum
48         fi
49
50         if [ -f "$test_root/$tree.$scm" ]; then
51                 sum "$test_root/$tree.$scm" >> $sum_tree_sum
52         fi
53
54         for d in $deptrees; do
55                 dscm=`choose_scm "$d"`
56                 if [ -f "$test_root/$d.$dscm" ]; then
57                 sum "$test_root/$d.$dscm" >> $sum_tree_sum
58                 fi
59         done
60 }
61
62 #############################
63 # send the logs to the master site
64 #############################
65
66 send_logs() {
67         if [ "$nologreturn" = "yes" ]; then
68                 echo "skipping log transfer"
69         else
70                 log="$1"
71                 err="$2"
72                 shift
73                 shift
74                 chmod 0644 "$log" "$err"
75
76                 # xargs -i is implemented differently or not at all.
77                 # GNU xargs did not implement "-I" until 4.2.9:
78                 xargs --version 2>&1 | grep "^GNU xargs" > /dev/null
79                 status=$?
80                 if [ x"$status" = x"0" ]; then
81                         XARGS_IS_GNU=yes
82                 fi
83
84                 if [ x"$XARGS_IS_GNU" = x"yes" ]; then
85                         XARGS_I="xargs -i"
86                 else
87                         XARGS_I="xargs -I '{}'"
88                 fi
89
90                 find $log -size +40000 | $XARGS_I sh -c 'dd if={} bs=1024 count=20000 of={}.tmp && mv {}.tmp {} &&  echo "\n***LOG TRUNCATED***" >> {}'
91                 find $err -size +40000 | $XARGS_I sh -c 'dd if={} bs=1024 count=20000 of={}.tmp && mv {}.tmp {} &&  echo "\n***LOG TRUNCATED***" >> {}'
92
93                 rsync $* -c -q --password-file=.password -z --timeout=200 \
94                         "$log" "$err" $host@build.samba.org::build_farm_data/
95         fi
96 }
97
98 #############################
99 # send the logs when they haven't changed
100 # the aim is to just update the servers timestamp.
101 # sending with a very large rsync block size does this
102 # with minimal network traffic
103 #############################
104
105 send_logs_skip() {
106         touch "$1" "$2"
107         send_logs "$1" "$2" -B 10000000
108 }
109
110 ############################
111 # fetch the latest copy of the tree
112 ############################
113
114 fetch_tree() {
115         if [ "$norsync" = "yes" ]; then
116                 echo "skipping tree transfer"
117         else
118                 fetchtree=$1
119                 if rsync --exclude=autom4te.cache/ --exclude=.svn/ --exclude=.git/ \
120                         --delete-excluded -q --partial --timeout=200 -ctrlpz --delete --ignore-errors \
121                         samba.org::ftp/unpacked/$fetchtree/ $test_root/$fetchtree; then
122                         echo "transferred $fetchtree OK"
123                 else
124                         echo "transfer of $fetchtree failed code $?"
125                         return 1
126                 fi
127         fi
128         return 0
129 }
130
131 ############################
132 # fetch the latest copy of the rev meta info
133 ############################
134
135 fetch_revinfo() {
136         tree=$1
137         scm=$2
138
139         test -z "$scm" && return 1
140         test x"$scm" = x"unknown" && return 1
141         test x"$scm" = x"cvs" && return 1
142
143         if [ "$norsync" = "yes" ]; then
144                 echo "skipping .revinfo.$scm transfer"
145         else
146                 if [ -r $test_root/$tree.$scm ]; then
147                         [ -f $test_root/$tree.$scm.old ] && rm -f $test_root/$tree.$scm.old
148                         [ -f $test_root/$tree.$scm ] && mv $test_root/$tree.$scm $test_root/$tree.$scm.old
149                 fi
150                 rsync -q --timeout=200 -clz --ignore-errors \
151                         samba.org::ftp/unpacked/$tree/.revinfo.$scm $test_root/$tree.$scm
152         fi
153         if [ -r $test_root/$tree.$scm ]; then
154                 return 0;
155         fi
156         return 1
157 }
158
159 ############################
160 # choose the scm that is used for the given project
161 ############################
162
163 choose_scm() {
164         tree=$1
165
166         case "$tree" in
167                         samba* | rsync | libreplace | talloc | tdb | ldb | pidl | ccache* | waf*)
168                         echo "git"
169                                 return 0
170                         ;;
171         esac
172
173         echo "svn"
174         return 0
175 }
176
177 locknesting=0
178
179 ############################
180 # grab a lock file. Not atomic, but close :)
181 # tries to cope with NFS
182 ############################
183
184 lock_file() {
185                 if [ -z "$lock_root" ]; then
186                         lock_root=`pwd`;
187                 fi
188
189                 lckf="$lock_root/$1"
190                 machine=`cat "$lckf" 2> /dev/null | cut -d: -f1`
191                 pid=`cat "$lckf" 2> /dev/null | cut -d: -f2`
192
193                 if [ "$pid" = "$$" ]; then
194                         locknesting=`expr $locknesting + 1`
195                         echo "lock nesting now $locknesting"
196                         return 0
197                 fi
198
199                 if test -f "$lckf"; then
200                         test x$machine = x$host || {
201                                 echo "lock file $lckf is valid for other machine $machine"
202                                 return 1
203                         }
204
205                         kill -0 $pid && {
206                                 echo "lock file $lckf is valid for process $pid"
207                                 return 1
208                         }
209
210                         echo "stale lock file $lckf for $machine:$pid"
211                         cat "$lckf"
212                         /bin/rm -f "$lckf"
213                 fi
214                 echo "$host:$$" > "$lckf"
215                 return 0
216 }
217
218 ############################
219 # unlock a lock file
220 ############################
221
222 unlock_file() {
223         if [ -z "$lock_root" ]; then
224                 lock_root=`pwd`;
225         fi
226         if [ "$locknesting" != "0" ]; then
227                 locknesting=`expr $locknesting - 1`
228                 echo "lock nesting now $locknesting"
229         else 
230                 lckf="$lock_root/$1"
231                 /bin/rm -f "$lckf"
232         fi
233 }
234
235 ############################
236 # run make, and print trace
237 ############################
238
239 do_make() {
240         # work out correct make command
241         case "$tree" in
242             waf*)
243                 MAKECOMMAND="./waf"
244                 ;;
245             *)
246                 MAKECOMMAND="$MAKE"
247                 if [ x"$MAKECOMMAND" = x ]; then
248                     MAKECOMMAND=make
249                 fi
250                 ;;
251         esac
252
253         MMTIME=$MAXTIME
254         # some trees don't need as much time
255         case "$tree" in
256                 rsync | tdb | talloc | libreplace | ccache* | waf*)
257                         if [ "$compiler" != "checker" ]; then
258                                 MMTIME=`expr $MMTIME / 5`
259                         fi
260                 ;;
261         esac
262
263         # special build for some trees
264         case "$tree" in
265             waf*)
266                 ./waf distclean && ./waf configure build
267                 ;;
268         esac
269
270
271         for t in $*; do
272                 if [ x"$BUILD_FARM_NUM_JOBS" = x ]; then
273                         echo "$MAKECOMMAND $t"
274                         $builddir/timelimit $MMTIME "$MAKECOMMAND" "$t"
275                         status=$?
276                 else
277                         # we can parallelize everything and all targets
278                         if [ x"$t" = xeverything ] || [ x"$t" = xall]; then
279                                 echo "$MAKECOMMAND" "-j$BUILD_FARM_NUM_JOBS"  "$t"
280                                 $builddir/timelimit $MMTIME "$MAKECOMMAND" "-j$BUILD_FARM_NUM_JOBS"  "$t"
281                                 status=$?
282                         else
283                                 echo "$MAKECOMMAND $t"
284                                 $builddir/timelimit $MMTIME "$MAKECOMMAND" "$t"
285                                 status=$?
286                         fi
287                 fi
288
289                 if [ $status != 0 ]; then
290                         case "$t" in
291                                 test|check|installcheck)
292                                         ;;
293                                 *)
294                                         #run again with V=1, so we see failed commands
295                                         $builddir/timelimit $MMTIME "$MAKECOMMAND" "$t" V=1
296                                         status=$?
297                                         ;;
298                         esac
299                 fi
300
301                 if [ $status != 0 ]; then
302                         return $status;
303                 fi
304
305         done
306
307         return 0
308 }
309
310
311 ############################
312 # do the coverage report
313 ############################
314
315 action_lcovreport() {
316         if [ "$LCOV_REPORT" = "yes" ]; then
317                 case "$tree" in
318                 lorikeet-heimdal*)
319                         lcov --directory $builddir --capture --output-file $builddir/$tree.lcov.info
320                         ;;
321                 samba_3_master*)
322                         lcov --base-directory $builddir --directory $builddir/.. --capture --output-file $builddir/$tree.lcov.info
323                         ;;
324                 samba_4*|tdb|talloc|ldb|libreplace)
325                         lcov --base-directory $builddir/bin --directory $builddir/bin --capture --output-file $builddir/$tree.lcov.info
326                         ;;
327                 waf)
328                         lcov --base-directory $builddir/demos --directory $builddir/demos --capture --output-file $builddir/$tree.lcov.info
329                         ;;
330                 *)
331                         lcov --base-directory $builddir --directory $builddir --capture --output-file $builddir/$tree.lcov.info
332                         ;;
333                 esac
334                 genhtml -o $builddir/coverage $builddir/$tree.lcov.info
335                 rc=$?
336                 echo "return code: $rc"
337         else
338                 echo "LCOV_REPORT not set and lcovreport asked"
339                 echo "Most probably an error please fix !"
340                 return 1
341         fi
342 }
343
344 action_callcatcherreport() {
345         if [ "$CALLCATCHER_REPORT" = "yes" ]; then
346                 case "$tree" in
347                 samba_3_master*)
348                         callanalyse `find $builddir/bin -name \*.so*` $builddir/bin/* | grep -v -f $srcdir/callcatcher-exceptions.grep > $builddir/coverage/unused-fns.txt
349                         ;;
350                 samba_4*)
351                         callanalyse `find $builddir/bin -name \*.so*` $builddir/bin/* | grep -v -f $srcdir/callcatcher-exceptions.grep > $builddir/coverage/unused-fns.txt
352                         ;;
353                 esac
354                 rc=$?
355                 echo "return code: $rc"
356         else
357                 echo "CALLCATCHER_REPORT not set and callcatcher asked"
358                 echo "Most probably an error please fix !"
359                 return 1
360         fi
361 }
362
363
364 ############################
365 # configure the tree
366 ############################
367
368 action_configure() {
369         # special handling for some trees
370         case "$tree" in
371             waf*)
372                 $builddir/timelimit $MAXTIME ./waf configure
373                 cstatus=$?
374                 echo "CONFIGURE STATUS: $cstatus"
375                 return $cstatus
376                 ;;
377         esac
378
379         if [ ! -x $srcdir/configure -a -r $srcdir/Makefile.PL ]; then
380                 perl $srcdir/Makefile.PL PREFIX="$prefix"
381                 cstatus=$?
382                 echo "CONFIGURE STATUS: $cstatus"
383                 return $cstatus;
384         fi
385
386         if [ ! -x $srcdir/configure ]; then
387                 ls -l $srcdir/configure
388                 echo "$srcdir/configure is missing"
389                 cstatus=255
390                 echo "CONFIGURE STATUS: $cstatus"
391                 return $cstatus;
392         fi
393
394         echo "CFLAGS=$CFLAGS"
395         echo configure options: $config_and_prefix
396         echo CC="$CCACHE $compiler" $srcdir/configure $config_and_prefix
397
398         CC="$CCACHE $compiler"
399         export CC
400         $builddir/timelimit $MAXTIME $srcdir/configure $config_and_prefix
401         cstatus=$?
402
403         if [ x"$cstatus" != x"0" ]; then
404                 if [ -f config.log ]; then
405                         echo "contents of config.log:"
406                         cat config.log
407                 fi
408
409                 # Waf style
410                 if [ -f bin/config.log ]; then
411                         echo "contents of config.log:"
412                         cat bin/config.log
413                 fi
414         fi
415         echo "CONFIGURE STATUS: $cstatus"
416         return $cstatus
417 }
418
419 ############################
420 # show the configure log
421 ############################
422
423 action_config_log() {
424
425         log_files="config.log bin/config.log"
426         for f in $log_files; do
427                 if [ -f $f ]; then
428                         echo "contents of config.log:"
429                         cat $f
430                         return 0
431                 fi
432         done
433         return 0
434 }
435
436 ############################
437 # show the config.h
438 ############################
439
440 action_config_header() {
441         hdr_files="config.h include/config.h include/autoconf/config.h bin/default/config.h bin/default/include/config.h bin/default/source3/include/config.h"
442         for h in $hdr_files; do
443                 if [ -f $h ]; then
444                         echo "contents of $h:"
445                         cat $h
446                         return 0
447                 fi
448         done
449
450         return 0
451 }
452
453
454
455 ############################
456 # build the tree
457 ############################
458 action_build() {
459         case "$tree" in
460         samba_4*)
461                 do_make everything
462                 bstatus=$?
463                 ;;
464         samba_3*)
465                 do_make everything torture
466                 bstatus=$?
467                 ;;
468         waf*)
469                 do_make build
470                 bstatus=$?
471                 ;;
472         *)
473                 do_make all
474                 bstatus=$?
475                 ;;
476         esac
477
478         echo "BUILD STATUS: $bstatus"
479
480         return $bstatus
481 }
482
483 ############################
484 # show static analysis results
485 ############################
486
487 action_cc_checker() {
488
489         # default to passing the cc_checker
490         cccstatus=0
491
492         if [ -f ibm_checker.out ]; then
493                 cat ibm_checker.out
494                 cccstatus=`cat ibm_checker.out | grep '^\-\- ' | wc -l`
495         fi
496
497         echo "CC_CHECKER STATUS: $cccstatus"
498         return $cccstatus;      
499 }
500
501 ############################
502 # install the tree
503 ############################
504
505 action_install() {
506         if [ -d $prefix ]; then
507                 if [ "$noclean" != "yes" ]; then
508                         rm -rf $prefix
509                 fi
510         fi
511
512         do_make install
513         istatus=$?
514         echo "INSTALL STATUS: $istatus"
515         return $istatus;
516 }
517
518 ############################
519 # test the tree
520 action_test_samba() {
521         do_make test
522         totalstatus=$?
523
524         # if we produced a test summary then show it
525         [ -f st/summary ] && {
526                 echo "TEST SUMMARY"
527                 cat st/summary
528         }
529
530         return "$totalstatus"
531 }
532
533 action_test_generic() {
534         CC="$compiler"
535         export CC
536         do_make installcheck
537         totalstatus=$?
538         echo "TEST STATUS: $totalstatus"
539         return "$totalstatus"
540 }
541
542 action_test_lorikeet_heimdal() {
543         CC="$compiler"
544         export CC
545         SOCKET_WRAPPER_DIR=`pwd`/sw
546         mkdir $SOCKET_WRAPPER_DIR
547         export SOCKET_WRAPPER_DIR
548         do_make check
549         totalstatus=$?
550         SOCKET_WRAPPER_DIR=
551         export SOCKET_WRAPPER_DIR
552         echo "TEST STATUS: $totalstatus"
553         return "$totalstatus"
554 }
555
556
557 #############################
558 # attempt some basic tests of functionaility
559 # starting as basic as possible, and getting incresingly complex
560 #############################
561
562 action_test() {
563         # Samba needs crufty code of its own for backward
564         # compatiblity.  I think a better way to do this in the future
565         # is to just call 'make installcheck'.
566         case "$tree" in
567         samba*|smb-build|pidl)
568                 action_test_samba
569                 ;;
570         lorikeet-heimdal*)
571                 action_test_lorikeet_heimdal
572                 ;;
573         *)
574                 action_test_generic
575                 ;;
576         esac
577 }
578
579 ###########################
580 # do a test build of a particular tree
581 # This is the master function called by generic.fns or
582 # host.fns
583 ###########################
584
585 test_tree() {
586         tree=$1
587         source=$2
588         compiler="$3"
589         shift
590         shift
591         shift
592         echo "Starting to deal with tree $tree with compiler $compiler"
593         if [ "$compiler" = "gcc" ] && [ "$tree" != "ccache" ] && [ "$tree" != "ccache-maint" ] && ccache -V > /dev/null 2>/dev/null; then
594                 CCACHE="ccache"
595                 export CCACHE
596         else
597                 CCACHE=""
598         fi
599
600         # limit our resource usage
601         ulimit -t $MAXTIME 2> /dev/null
602
603         # max mem size 100M
604         ulimit -m $MAXMEM 2> /dev/null
605
606         # max file size 100M
607         # darn, this affects sparse files too! disable it
608         # ulimit -f 100000 2> /dev/null
609
610         # try and limit the number of open files to 250. That means we'll discover
611         # fd leaks faster
612         ulimit -n 250 2> /dev/null
613
614         # Keep stuff private
615         umask 077
616
617         if [ -z "$test_root" ]; then
618                 test_root=`pwd`
619         fi
620
621         log="build.$tree.$host.$compiler.log"
622         err="build.$tree.$host.$compiler.err"
623         sum="build.$tree.$host.$compiler.sum"
624         lck="build.$tree.lck"
625                 srcdir="$test_root/$tree/$source"
626
627         lock_file "$lck" || {
628                 return
629         }
630
631         # work out what other trees this package depends on
632         deptrees=""
633         case "$tree" in
634                 samba-gtk)
635                 deptrees="samba_4_0_test"
636                 ;;
637         esac
638
639         scm=`choose_scm "$tree"`
640
641         # pull the entries, if any
642         # Remove old .svn or .git files
643         # Move the current .svn org .git to .svn.old or
644         # .git.old then fetch the new from rsync
645         if fetch_revinfo "$tree" "$scm"; then
646                 for d in $deptrees; do
647                         # If there is dependency substree(s) we add info
648                         # from the dependency tree so that we
649                         # can rebuild in case one of them has changed
650                         dscm=`choose_scm "$d"`
651                         if [ -f "$test_root/$d.$dscm" ]; then
652                                 if [ "$d" != "$tree" ]; then
653                                         cat "$test_root/$d.$dscm" >> $test_root/$tree.$scm
654                                 fi
655                         fi
656                 done
657                 [ -f $test_root/$tree.$compiler.$scm.old ] && rm -f $test_root/$tree.$compiler.$scm.old
658                 [ -f $test_root/$tree.$compiler.$scm ] && mv $test_root/$tree.$compiler.$scm $test_root/$tree.$compiler.$scm.old
659                 [ -f $test_root/$tree.$scm ] && cp $test_root/$tree.$scm $test_root/$tree.$compiler.$scm
660
661                 if [ -f $test_root/$tree.$compiler.$scm.old ] && \
662                                 cmp $test_root/$tree.$compiler.$scm $test_root/$tree.$compiler.$scm.old > /dev/null; then
663
664                         echo "skip: $tree.$compiler nothing changed in $scm"
665                         cd $test_root
666                         send_logs_skip "$log" "$err"
667                         unlock_file "$lck"
668                         return
669                 fi
670         fi
671
672         # pull the tree
673         fetch_tree "$tree" || {
674                 cd $test_root
675                 unlock_file "$lck"
676                 return
677         }
678
679         # check for essential files
680         case "$tree" in
681             pidl)
682                 # no generated files
683                 ;;
684             waf*)
685                 if [ ! -x $srcdir/waf ]; then
686                     echo "skip: $tree.$compiler waf not present, try again next time!"
687                     cd $test_root
688                     unlock_file "$lck"
689                     return
690                 fi
691                 ;;
692             *)
693                 if [ ! -x $srcdir/configure ]; then
694                     echo "skip: $tree.$compiler configure not present, try again next time!"
695                     cd $test_root
696                     unlock_file "$lck"
697                     return
698                 fi
699                 ;;
700         esac
701
702         echo "Starting build of $tree.$compiler in process $$ at `date`"
703
704
705         # Parameters for the build depending on the tree
706         case "$tree" in
707                 *)
708                         builddir=$srcdir
709                         export builddir
710                         ;;
711         esac
712
713         #Fix the user
714         if [ ! x$USER = x"" ]; then
715                 whoami=$USER
716         else 
717                 if [ ! x$LOGNAME = x"" ]; then
718                         whoami=$LOGNAME
719                 else
720                         whoami=build
721                 fi
722         fi
723
724         # build the timelimit utility
725         echo "Building timelimit"
726         mkdir -p $builddir
727         echo $compiler $TIMELIMIT_FLAGS -o $builddir/timelimit $test_root/timelimit.c
728         $compiler $TIMELIMIT_FLAGS -o $builddir/timelimit $test_root/timelimit.c || exit 1
729
730         # build the killbysubdir utility
731         echo "Building killbysubdir"
732         echo $compiler -o $builddir/killbysubdir $test_root/killbysubdir.c
733         $compiler -o $builddir/killbysubdir $test_root/killbysubdir.c
734
735         prefix="$test_root/prefix/$tree.$compiler"
736         mkdir -p "$prefix"
737
738         # This can be defined in <host>.fns files
739         sw_config=$config
740
741         case "$tree" in
742         lorikeet-heimdal)
743                 sw_config="$config --enable-socket-wrapper"
744                 ;;
745         samba_4*)
746                 sw_config="$config --enable-socket-wrapper"
747                 sw_config="$sw_config --enable-nss-wrapper"
748                 sw_config="$sw_config --enable-uid-wrapper"
749                 ;;
750         samba_3*)
751                 sw_config="$config --enable-socket-wrapper"
752                 sw_config="$sw_config --enable-nss-wrapper"
753                 ;;
754         samba-gtk)
755                 PKG_CONFIG_PATH="$test_root/prefix/samba_4_0_test.$compiler/lib/pkgconfig"
756                 export PKG_CONFIG_PATH
757                 ;;
758         *)
759                 testsuite=testsuite
760                 ;;
761         esac
762
763         if [ "$LCOV_REPORT" = "yes" ]; then
764                 PRE_GCOV_CFLAGS=$CFLAGS
765                 PRE_GCOV_LDFLAGS=$LDFLAGS
766                 GCOV_FLAGS="--coverage"
767                 CFLAGS="$CFLAGS $GCOV_FLAGS" 
768                 LDFLAGS="$LDFLAGS $GCOV_FLAGS" 
769                 export CFLAGS LDFLAGS
770         fi
771
772         config_and_prefix="$sw_config --prefix=$prefix"
773
774         # see if we need to rebuild
775         sum_tree $test_root $tree $sum $scm
776         echo "CFLAGS=$CFLAGS $config_and_prefix" >> $sum
777
778         if [ -f "$sum.old" ] && cmp "$sum" "$sum.old" > /dev/null; then
779                 echo "skip: $tree.$compiler nothing changed"
780                 cd $test_root
781                 send_logs_skip "$log" "$err"
782                 unlock_file "$lck"
783                 echo "Ending build of $tree.$compiler in process $$ at `date`"
784                 if [ "$LCOV_REPORT" = "yes" ]; then
785                     CFLAGS=$PRE_GCOV_CFLAGS
786                     LDFLAGS=$PRE_GCOV_LDFLAGS
787                     export CFLAGS LDFLAGS
788                 fi
789                 return
790         fi
791
792         # we do need to rebuild - save the old sum
793         [ -f $sum.old ] && /bin/rm -f $sum.old
794         mv $sum $sum.old
795
796         #Action == what to do ie. configure config_log ...
797         actions="$*"
798
799         if [ "$actions" = "" ]; then
800                 actions="configure config_log config_header build install test $EXTRA_ACTIONS"
801         fi
802
803         # start the build
804         (
805         {
806                 # we all want to be able to read the output...
807                 LANG=C
808                 export LANG
809
810                 uname -a
811
812                 echo ""
813                 echo "build_test                  : $build_test_id"
814                 echo "build_test.fns      : $build_test_fns_id"
815                 echo "local settings file : $build_test_settings_local_file"
816                 echo "local functions file: $build_test_fns_local_file"
817                 echo "used .fns file      : $build_test_used_fns_file"
818                 echo ""
819
820                 # we need to be able to see if a build farm machine is accumulating
821                 # stuck processes. We do this in two ways, as we don't know what style
822                 # of ps it will have
823                 ps xfuw 2> /dev/null
824                 ps -fu $USER 2> /dev/null
825
826                 echo "building $tree with CC=$compiler on $host at "`date`
827                 echo "builddir=$builddir"
828                 echo "prefix=$prefix"
829
830                 echo "Showing limits"
831                 ulimit -a 2> /dev/null
832
833                 # the following is for non-samba builds only
834                 if [ "$scm" = "svn" -a -r $test_root/$tree.svn ]; then
835                         h_rev=`grep 'Revision: ' $test_root/$tree.svn | cut -d ':' -f2 | cut -d ' ' -f2 | sed 1q`
836                         if [ -n "$h_rev" ]; then
837                                 echo "HIGHEST SVN REVISION: $h_rev"
838                         fi
839                         rev=`grep 'Last Changed Rev: ' $test_root/$tree.svn | cut -d ':' -f2 | cut -d ' ' -f2 | sed 1q`
840                         if [ -n "$rev" ]; then
841                         echo "BUILD REVISION: $rev"
842                         fi
843                 elif [ "$scm" = "git" -a -r $test_root/$tree.git ]; then
844                         csha1=`cat $test_root/$tree.git |head -3 | tail -1`
845                         if [ -n "$csha1" ]; then
846                                 echo "BUILD COMMIT REVISION: $csha1"
847                         fi
848                         cdate=`cat $test_root/$tree.git |head -4 | tail -1`
849                         if [ -n "$cdate" ]; then
850                                 echo "BUILD COMMIT DATE: $cdate"
851                         fi
852                         ctime=`cat $test_root/$tree.git |head -2 | tail -1`
853                         if [ -n "$ctime" ]; then
854                                 echo "BUILD COMMIT TIME: $ctime"
855                   fi
856                 fi
857
858                 if [ -x $builddir/killbysubdir ]; then
859                         echo "$builddir/killbysubdir $builddir in `pwd`"
860                         $builddir/killbysubdir $builddir
861                 fi
862
863                 for action in $actions; do
864
865                         echo Running action $action
866
867                         date
868
869                         cd $builddir || exit 1
870                         export srcdir
871                         df .
872                         mount
873                         vmstat
874
875                         if [ "x$PREHOOKS" != "x" ]; then
876                                 for hooks in $PREHOOKS; do
877                                         if [ "x$hooks" = "x$action" ]; then
878                                                 ( prehook_$action )
879                                         fi
880                                 done
881                         fi
882
883                         ( action_$action )
884                         action_status=$?
885
886                         if [ "x$POSTHOOKS" != "x" ]; then
887                                 for hooks in $POSTHOOKS; do
888                                         if [ "x$hooks" = "x$action" ]; then
889                                                 ( posthook_$action )
890                                         fi
891                                 done
892                         fi
893
894                         df .
895
896                         if [ $action_status != 0 ]; then
897                                 echo "ACTION FAILED: $action";
898                                 echo " return code $action_status $action";
899                         else
900                                 echo "ACTION PASSED: $action";
901                         fi
902
903                         if [ $action_status != 0 ]; then 
904                                 break;
905                         fi
906                 done
907
908
909                 if [ "$noclean" = "yes" ]; then
910                         echo cleanup skipped!
911                 else
912                         echo cleaning up
913                         do_make clean
914                 fi
915                 date
916         } 3>&2 2>&1 1>&3 | tee "$err"
917         ) > "$log" 2>&1
918         # be aware the above channel swap may sometimes result in unordered
919         # stdout/stderr merge
920
921         if [ "$LCOV_REPORT" = "yes" ]; then
922                 chmod u=rwX,g=rX,o=rX -R $builddir/coverage
923                 rsync -rct -q --password-file=.password -z --timeout=200 \
924                         $builddir/coverage/ $host@build.samba.org::lcov_data/$host/$tree/
925                 CFLAGS=$PRE_GCOV_CFLAGS
926                 LDFLAGS=$PRE_GCOV_LDFLAGS
927                 export CFLAGS LDFLAGS
928         fi
929
930         cd $test_root
931
932         /bin/rm -rf $prefix
933         # send the logs to the master site
934         send_logs "$log" "$err"
935
936         # cleanup
937         echo "Ending build of $tree.$compiler in process $$ at `date`"
938         unlock_file "$lck"
939 }
940
941 #########################################################
942 # if you want to build only one project at a time
943 # add 'global_lock' after 'per_run_hook' and
944 # 'global_unlock' to the end of the file
945 #########################################################
946
947 global_lock() {
948         lock_file "global.lck" || {
949                 exit 0
950         }
951 }
952
953 global_unlock() {
954         unlock_file "global.lck"
955 }
956
957 delete_old_tree() {
958         otree=$1
959         test -z "$otree" && return 0;
960
961         rm -rf $otree
962         rm -rf $otree.svn
963         rm -rf $otree.*.svn
964         rm -rf $otree.git
965         rm -rf $otree.*.git
966         rm -rf build.$otree.*
967 }
968
969 # this is a special fn that allows us to add a "special" hook to the build
970 # farm that we want to do to the build farm. never leave it empty. instead,
971 # use ":" as the fn body.
972 per_run_hook() {
973         # kill old processes on systems with a known problem
974         case $host in
975         nohost)
976                 echo "just a placeholder";
977                 ;;
978         deckchair)
979                 rm -f deckchair.fns
980                 ;;
981         esac
982
983         # trim the log if too large
984         if [ "`wc -c < build.log`" -gt 2000000 ]; then
985         rm -f build.log
986         fi
987
988         old_trees="web popt distcc samba-gtk smb-build lorikeet-heimdal samba_3_2"
989         old_trees="$old_tree samba_3_2_test samba4 samba_4_0_waf samba_4_0_waf.metze"
990         old_trees="$old_tree samba_3_X_test samba_3_X_devel samba_3_X_devel samba_3_waf"
991         for d in $old_trees; do
992                 delete_old_tree $d
993         done
994 }
995
996
997 ######################################################
998 # main code that is run on each call to the build code
999 ######################################################
1000 rsync --timeout=200 -q -az build.samba.org::build_farm/*.c .
1001
1002
1003 # build.log can grow to an excessive size, trim it beyond 50M
1004 if [ -f build.log ]; then
1005         find build.log -size +100000 -exec /bin/rm '{}' \;
1006 fi